--ucp.lua (update cultivator & plough)
-- restores the function that cultivators and ploughs remove spray pattern
-- stellt die Funktion wieder her das Grubber und Pflge das Dngerlayer entfernen
-- Copyright:  Sven777b (03/2013)


ucp = {};
ucp.backupUCA = Utils.updateCultivatorArea;
ucp.backupUPA = Utils.updatePloughArea;

function ucp.updateCultivatorArea(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, forced, commonForced, angle)
	local x,z, widthX,widthZ, heightX,heightZ = Utils.getXZWidthAndHeight(g_currentMission.terrainDetailId, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ);
	setDensityParallelogram(g_currentMission.terrainDetailId, x, z, widthX, widthZ, heightX, heightZ, g_currentMission.sprayChannel, 1, 0);
end;

function ucp.updatePloughArea(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ, forced, commonForced, angle)
	local x,z, widthX,widthZ, heightX,heightZ = Utils.getXZWidthAndHeight(g_currentMission.terrainDetailId, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ);
	setDensityParallelogram(g_currentMission.terrainDetailId, x, z, widthX, widthZ, heightX, heightZ, g_currentMission.sprayChannel, 1, 0);
end;

function ucp.combineFunction(oldFunc, newFunc)
	return function(...)
		local ret=oldFunc(...);
		newFunc(...);
		return ret;
	end
end

Utils.updateCultivatorArea = ucp.combineFunction(Utils.updateCultivatorArea, ucp.updateCultivatorArea);
Utils.updatePloughArea = ucp.combineFunction(Utils.updatePloughArea, ucp.updatePloughArea);